package org.pweitz.reactnative.locationswitch;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.huawei.hms.api.HuaweiApiAvailability;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class LocationSwitchPackage implements ReactPackage {

    public List<Class<? extends JavaScriptModule>> createJSModules() {
        return Collections.emptyList();
    }

    public static boolean isGooglePlayServicesAvailable(ReactApplicationContext context) {
       int result =  GoogleApiAvailability.getInstance().isGooglePlayServicesAvailable(context);

       // TODO: Handle other possible success types.
       return result == ConnectionResult.SUCCESS || result == ConnectionResult.SERVICE_UPDATING;
   }

    public static boolean isHMSAvailable(ReactApplicationContext context) {
        int result =  HuaweiApiAvailability.getInstance().isHuaweiMobileServicesAvailable(context);
        // TODO: Handle other possible success types.
        return result == com.huawei.hms.api.ConnectionResult.SUCCESS;
    }

    @Override
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        return Collections.emptyList();
    }

    @Override
    public List<NativeModule> createNativeModules(
            ReactApplicationContext reactContext) {
        List<NativeModule> modules = new ArrayList<>();
        if (isHMSAvailable(reactContext) && !isGooglePlayServicesAvailable(reactContext)) {
            modules.add(new Module(reactContext));
        } else {
            modules.add(new ModuleWithGoogle(reactContext));
        }

        return modules;
    }
}
