package org.pweitz.reactnative.locationswitch;

import android.app.Activity;
import android.content.Intent;

import com.facebook.react.bridge.ActivityEventListener;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;

import com.huawei.hms.api.HuaweiApiAvailability;


public class ModuleWithGoogle extends ReactContextBaseJavaModule implements ActivityEventListener {


    public ModuleWithGoogle(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    public static boolean isHMSAvailable(ReactApplicationContext context) {
        int result =  HuaweiApiAvailability.getInstance().isHuaweiMobileServicesAvailable(context);

        // TODO: Handle other possible success types.
        return result == com.huawei.hms.api.ConnectionResult.SUCCESS;
    }


    @Override
    public String getName() {
        return "RNReactNativeLocationSwitch";
    }

    @ReactMethod
    public void isLocationEnabled(Callback successCallback, Callback errorCallback) {
        LocationSwitchWithGoogle.getInstance().isLocationEnabled(getCurrentActivity(),
                successCallback, errorCallback);
    }

    @ReactMethod
    public void enableLocationService(int interval, boolean requestHighAccuracy,
                                      Callback successCallback, Callback errorCallback) {
        LocationSwitchWithGoogle.getInstance().setup(
                successCallback, errorCallback, interval, requestHighAccuracy);
        LocationSwitchWithGoogle.getInstance().displayLocationSettingsRequest(
                getCurrentActivity());
    }


    /**
     * ActivityEventListener methods
     **/
    public void onNewIntent(Intent intent) {

    }

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        LocationSwitchWithGoogle.getInstance().onActivityResult(requestCode, resultCode);
    }

    public void onActivityResult(Activity activity, int requestCode, int resultCode, Intent data) {
        LocationSwitchWithGoogle.getInstance().onActivityResult(requestCode, resultCode);
    }
}